<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Exception;
use SM\Traits\TQuery;

class Sm00004101RelatorioCustomizavelContratoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getRelatorioCustomizavelContrato($filtro)
    {

        $sql = "SELECT FCT_CONTRATO.NRDIASREAJAUTOMATICO,
                        FCT_ORCAMENTO.DTACEITEORCA,
                
                (SELECT MAX(DTAPROVCONTR) AS DTAPROVCONTR
                    FROM FCT_APROVACONTRATO
                    WHERE NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO
                    AND IDAPROCCONTR = 'A') AS DTAPROVCONTR,
                        NVL(FCT_REFEORCACONT.IDGERADOPOR, 'CONTRATO') AS IDGERADOPOR,
                        FCT_CONTRATO.NRSEQCONTRATO,
                        FCT_CONTRATO.IDTPCONTRATO,
                        FCT_CONTRATO.NRCONTRATOFCT,
                        FCT_CONTRATO.NRCONTRATOFCT || ' - ' || FCT_CONTRATO.DSREFERENCIACONT AS NMCONTRATO,
                        TO_CHAR(NVL(FCT_CONTRATO.DTINIVIGENCONT, FCT_CONTRATO.DTINICIOCONTRATO), 'DD/MM/YYYY') AS DTINICONTRATO,
                        TO_CHAR(NVL(FCT_CONTRATO.DTFINVIGENCONT, FCT_CONTRATO.DTFIMCONTRATO), 'DD/MM/YYYY') AS DTFINCONTRATO,
                        FCT_CONTRATO.NRVERSAOCONTRATO,
                        FCT_CONTRATO.CDFILIALORCA,
                        FILIAL.NMFILIAL,
                        FCT_CONTRATO.NRSEQMODCONTRA,
                        FCT_MODELOCONTRATO.NMMODCONTRATO,
                        FCT_CONTRATO.NRPARCNEGOCIO,
                        PARCNEGOCIO.NMPRINCIPALPARC,
                        PARCNEGOCIO.NRINSCRICAOPARC,
                        PARCNEGOCIO.NMSECUNDARIPARC,
                        FCT_CONTRATO.DSREFERENCIACONT,
                        TO_CHAR(FCT_CONTRATO.DTINICIOCONTRATO, 'DD/MM/YYYY') AS DTINICIOCONTRATO,
                        TO_CHAR(FCT_CONTRATO.DTFIMCONTRATO, 'DD/MM/YYYY') AS DTFIMCONTRATO,
                        NULL AS NRDIASVIGCONT,
                        FCT_CONTRATO.NRDIASPRAZOCONT,
                        FCT_CONTRATO.NRDIAVENPARCFAT,
                        FCT_CONTRATO.CDINDFINCONT,
                        FCT_CONTRATO.CDTPINDFINCON,
                        FCT_CONTRATO.IDPERVALFINCON,
                        FCT_CONTRATO.DTPADREAJCONT,
                        FCT_CONTRATO.DTPADRPRORGCONT,
                        DECODE(FCT_CONTRATO.DTINIVIGENCONT, NULL, FCT_CONTRATO.NRDIASPRAZOCONT, FCT_CONTRATO.NRDIASPRORGCONT) AS NRDIASPRORGCONT,
                        FCT_CONTRATO.QTPOSTOTRABCONT,
                        FCT_CONTRATO.IDORIGCONTRATO,
                        TO_CHAR(FCT_CONTRATO.DTPEDRESCISAOCONTR, 'DD/MM/YYYY') AS DTPEDRESCISAOCONTR,
                        TO_CHAR(FCT_CONTRATO.DTRECISAOCONTR, 'DD/MM/YYYY') AS DTRECISAOCONTR,
                        FCT_CONTRATO.NRMOTIVORESCISAO,
                        FCT_MOTIVORESCISAO.DSMOTIVORESCISAO,
                        FCT_CONTRATO.IDSITUACAOCONTRATO,
                        FCT_CONTRATO.IDTPEXCLUSAOPARCELA,
                        FCT_CONTRATO.CDFILIALFATURA,
                        FCT_CONTRATO.DSOBSERVACAOCONT,
                        FCT_CONTRATO.NRSEQCONTRATOPAI,
                        FCT_CONTRATO.CDSEQCONTRATO,
                        FCT_CONTRATO.IDQTDIASCOMPCON,
                        FCT_CONTRATO.NRQTDIASCOMPCON,
                        FCT_CONTRATO.IDTPCOMPETCONT,
                        FCT_CONTRATO.NRDIACOMPETCONT,
                        FCT_CONTRATO.IDTPDTEMISSNF,
                        FCT_CONTRATO.NRDIADTEMISSNF,
                        FCT_CONTRATO.IDTPDTVENC,
                        FCT_CONTRATO.IDTPREAJUSTE,
                        FCT_CONTRATO.IDTPMESREAJUSTE,
                        FCT_CONTRATO.NRQTDREAJUSTE,
                        FCT_CONTRATO.IDSOMAFATUCONT,
                        FCT_CONTRATO.IDTPFATUINCOMP,
                        NVL(FCT_CONTRATO.DTINIVIGENCONT, FCT_CONTRATO.DTINICIOCONTRATO) AS DTINIVIGENCONT,
                        NVL(FCT_CONTRATO.DTFINVIGENCONT, FCT_CONTRATO.DTFIMCONTRATO) AS DTFINVIGENCONT,
                        FCT_CONTRATO.IDBLOQSEMMEDIC,
                        FCT_CONTRATO.IDFATURACONTR,
                        FCT_CONTRATO.CDMODPGTO,
                        MODPGTO.DSMODPGTO,
                        FCT_CONTRATO.DTINICFATCONTR,
                        FCT_CONTRATO.CDMNEMCRIACAO,
                        FCT_CONTRATO.CDCENTCUST,
                        CENTCUST.NMCENTCUST,
                        FCT_CONTRATO.NRPARCINTERLOCUTOR,
                        DECODE(FCT_REFEORCACONT.IDGERADOPOR, 'PROPOSTA', FCT_ORCAMENTO.NRORCAMENTO, NULL) AS NRORCAMENTO,
                        FCT_ORCAMENTO.IDPROPALIMENTICIA,
                        FCT_CONTRATO.NRORG,
                        FCT_CONTRATO.IDATIVO,
                        FCT_CONTRATO.DTINCLUSAO,
                        FCT_CONTRATO.CDOPERINCLUSAO,
                        OPINC.NMOPERADOR AS NMOPERINCLUSAO,
                        FCT_CONTRATO.NRORGINCLUSAO,
                        FCT_CONTRATO.DTULTATU,
                        FCT_CONTRATO.CDOPERULTATU,
                        OPATU.NMOPERADOR AS NMOPERULTATU,
                        FCT_CONTRATO.NRORGULTATU,
                        FCT_REFEORCACONT.NRSEQORCAMENTO,
                        MODELO.IDUTILIZACOMP,
                        FCT_CONTRATO.QTPARCELASFATU,
                        FCT_CONTRATO.NRDIAVENCPARCELASFATU,
                        FCT_CONTRATO.CDOPERRESPONSAVEL,
                        OPERRESP.NMOPERADOR AS NMOPERRESP,
                        TOTCONT.VRTOTALCONT,
                        FCT_CAPAPARAMFATCON.IDTPFATURA,
                        FCT_CAPAPARAMFATCON.QTPARCELASFATU AS QTPARCELASFATUNOVO,
                        FCT_CONTRATO.DSJUSTIFCANCRENEG,
                        FCT_CONTRATO.DSJUSTIFICAENCERRA,
                        FCT_ORCAMENTO.NRORCAMENTOMODELO,
                        NVL(FCT_CONTRATO.NRTIPOORCAMENTO, FCT_REFEORCACONT.NRTIPOORCAMENTO) AS NRTIPOORCAMENTO,
                        FCT_TIPOORCAMENTO.NMTIPOORCAMENTO,
                        FCT_CONTRATO.NRTIPOORCAMENTO AS NRTIPOORCAMENTO_CONT,
                        ESCCONT.NMTIPOORCAMENTO AS NMTIPOORCAMENTO_CONT,
                        NVL(FCT_TIPOORCAMENTO.IDUTILIZAVARPRECO, 'N') AS IDUTILIZAVARPRECO,
                
                (SELECT COUNT(*)
                    FROM FCT_TRABSERVCONTRATO
                    WHERE NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO
                    AND NRORG = FCT_CONTRATO.NRORG) AS QTITENSTRABSERV,
                        NVL(FCT_TIPOORCAMENTO.IDTIPOORCA, 'T') AS IDTIPOORCA,
                        FCT_CONTRATO.IDREAJUSTEAUTOMATICO,
                        FCT_CONTRATO.IDRENOVACAOAUTOMATICA,
                        FCT_CONTRATO.IDASSELETRDIGITAL,
                        FCT_CONTRATO.DTSUSPENSAO,
                        FCT_CONTRATO.NRTIPORESCISAO,
                        FCT_CONTRATO.VRPENDENCIAFIN,
                        FCT_CONTRATO.CDOPERSOLSUSPENSAO,
                        FCT_CONTRATO.DSJUSTIFCASUSPENSAO,
                        OPERSUSP.NMOPERADOR AS OPERSOLSUSPENSAO,
                        DECODE(NVL(NEGCONT.NRNEGCONTRATO, NEGAGRUPA.NRNEGCONTRATO), NULL, 'N', 'S') AS NEGOCIADO,
                        NEGCONT.NRNEGCONTRATO,
                        MOTIVOPARALISA.DSMOTIVOPARALISACAO,
                        NVL(NEGCONT.NRMOTIVOPARALISACAO, NEGAGRUPA.NRMOTIVOPARALISACAO) AS NRMOTIVOPARALISACAO,
                        FCT_CONTRATO.IDENVIADOCOPERRESPCONCASS,
                        FCT_CONTRATO.IDAGRUPPARC,
                        FCT_CONTRATO.IDSITUACAORESCISAO,
                        FCT_TIPORESCISAO.DSTIPORESCISAO,
                        FCT_CONTRATO.IDMUNIPRESTSERV,
                        FCT_CONTRATO.IDINTEGRACAOFM,
                        FCT_CONTRATO.IDINTEGRALOCAISFM,
                        FCT_CONTRATO.IDINTEGRAMEDICAOFM,
                        FCT_CONTRATO.CDIDIOM,
                        IDIOMA.NMIDIOMA,
                        FCT_CONTRATO.NRMOEDA,
                        MOEDA.NMMOEDA
                FROM FCT_CONTRATO
                LEFT JOIN FCT_TIPORESCISAO ON FCT_CONTRATO.NRTIPORESCISAO = FCT_TIPORESCISAO.NRTIPORESCISAO
                LEFT JOIN FCT_REFEORCACONT ON FCT_CONTRATO.NRSEQCONTRATO = FCT_REFEORCACONT.NRSEQCONTRATO
                AND FCT_CONTRATO.NRORG = FCT_REFEORCACONT.NRORG
                LEFT JOIN FCT_ORCAMENTO ON FCT_REFEORCACONT.NRSEQORCAMENTO = FCT_ORCAMENTO.NRSEQORCAMENTO
                AND FCT_REFEORCACONT.NRORG = FCT_ORCAMENTO.NRORG
                LEFT JOIN
                (SELECT SUM(VRTOTITEMCOMDESC) AS VRTOTALCONT,
                        NRSEQCONTRATO,
                        NRORG
                    FROM FCT_NEGOCIACAOCONTRATO
                    GROUP BY NRSEQCONTRATO,
                            NRORG) TOTCONT ON FCT_CONTRATO.NRSEQCONTRATO = TOTCONT.NRSEQCONTRATO
                AND FCT_CONTRATO.NRORG = TOTCONT.NRORG
                LEFT JOIN FCT_CAPAPARAMFATCON ON FCT_CONTRATO.NRSEQCONTRATO = FCT_CAPAPARAMFATCON.NRSEQCONTRATO
                AND FCT_CONTRATO.NRORG = FCT_CAPAPARAMFATCON.NRORG
                LEFT JOIN OPERADOR OPERRESP ON FCT_CONTRATO.CDOPERRESPONSAVEL = OPERRESP.CDOPERADOR
                AND FCT_CONTRATO.NRORG = OPERRESP.NRORG
                LEFT JOIN FILIAL ON FCT_CONTRATO.CDFILIALORCA = FILIAL.CDFILIAL
                AND FCT_CONTRATO.NRORG = FILIAL.NRORG
                LEFT JOIN FCT_MODELOCONTRATO ON FCT_CONTRATO.NRSEQMODCONTRA = FCT_MODELOCONTRATO.NRSEQMODCONTRA
                AND FCT_CONTRATO.NRORG = FCT_MODELOCONTRATO.NRORG
                LEFT JOIN PARCNEGOCIO ON FCT_CONTRATO.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                AND FCT_CONTRATO.NRORG = PARCNEGOCIO.NRORG
                LEFT JOIN CENTCUST ON FCT_CONTRATO.CDCENTCUST = CENTCUST.CDCENTCUST
                AND FCT_CONTRATO.NRORG = CENTCUST.NRORG
                LEFT JOIN MODPGTO ON FCT_CONTRATO.CDMODPGTO = MODPGTO.CDMODPGTO
                AND FCT_CONTRATO.NRORG = MODPGTO.NRORG
                LEFT JOIN FCT_ORCAMENTOMODELO MODELO ON FCT_ORCAMENTO.NRORCAMENTOMODELO = MODELO.NRORCAMENTOMODELO
                AND FCT_ORCAMENTO.NRORG = MODELO.NRORG
                LEFT JOIN OPERADOR OPINC ON FCT_CONTRATO.CDOPERINCLUSAO = OPINC.CDOPERADOR
                AND FCT_CONTRATO.NRORG = OPINC.NRORG
                LEFT JOIN OPERADOR OPATU ON FCT_CONTRATO.CDOPERULTATU = OPATU.CDOPERADOR
                AND FCT_CONTRATO.NRORG = OPATU.NRORG
                LEFT JOIN FCT_TIPOORCAMENTO ON NVL(FCT_CONTRATO.NRTIPOORCAMENTO, FCT_REFEORCACONT.NRTIPOORCAMENTO) = FCT_TIPOORCAMENTO.NRTIPOORCAMENTO
                AND FCT_CONTRATO.NRORG = FCT_TIPOORCAMENTO.NRORG
                LEFT JOIN FCT_TIPOORCAMENTO ESCCONT ON FCT_CONTRATO.NRTIPOORCAMENTO = ESCCONT.NRTIPOORCAMENTO
                AND FCT_CONTRATO.NRORG = ESCCONT.NRORG
                LEFT JOIN FCT_MOTIVORESCISAO ON FCT_MOTIVORESCISAO.NRMOTIVORESCISAO = FCT_CONTRATO.NRMOTIVORESCISAO
                AND FCT_MOTIVORESCISAO.NRORG = FCT_CONTRATO.NRORG
                LEFT JOIN OPERADOR OPERSUSP ON FCT_CONTRATO.CDOPERSOLSUSPENSAO = OPERSUSP.CDOPERADOR
                LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGR ON FCT_CONTRATO.NRSEQCONTRATO = RELAGR.NRSEQCONTRATO
                AND FCT_CONTRATO.NRORG = RELAGR.NRORG
                LEFT JOIN
                (SELECT MAX(NEG.NRNEGCONTRATO) AS NRNEGCONTRATO,
                        MAX(NEG.NRMOTIVOPARALISACAO) AS NRMOTIVOPARALISACAO,
                        NEG.NRSEQCONTRATO,
                        TRUNC(MIN(PARC.DTINIPARCNEGOCIA)) AS DATAINI,
                        TRUNC(MAX(PARC.DTFIMPARCNEGOCIA)) AS DATAFIN
                    FROM FCT_NEGCONTRATO NEG
                    INNER JOIN FCT_PARCELASNEGCONTR PARC ON NEG.NRNEGCONTRATO = PARC.NRNEGCONTRATO
                    GROUP BY NEG.NRSEQCONTRATO) NEGCONT ON FCT_CONTRATO.NRSEQCONTRATO = NEGCONT.NRSEQCONTRATO
                AND TRUNC(SYSDATE) BETWEEN NEGCONT.DATAINI AND NEGCONT.DATAFIN
                LEFT JOIN
                (SELECT MAX(NEG.NRNEGCONTRATO) AS NRNEGCONTRATO,
                        MAX(NEG.NRMOTIVOPARALISACAO) AS NRMOTIVOPARALISACAO,
                        NEG.NRAGRUPAMENTO,
                        TRUNC(MIN(PARC.DTINIPARCNEGOCIA)) AS DATAINI,
                        TRUNC(MAX(PARC.DTFIMPARCNEGOCIA)) AS DATAFIN
                    FROM FCT_NEGCONTRATO NEG
                    INNER JOIN FCT_PARCELASNEGCONTR PARC ON NEG.NRNEGCONTRATO = PARC.NRNEGCONTRATO
                    WHERE NEG.NRAGRUPAMENTO IS NOT NULL
                    AND NEG.NRSEQCONTRATO IS NULL
                    GROUP BY NEG.NRAGRUPAMENTO) NEGAGRUPA ON RELAGR.NRAGRUPAMENTO = NEGAGRUPA.NRAGRUPAMENTO
                AND TRUNC(SYSDATE) BETWEEN NEGAGRUPA.DATAINI AND NEGAGRUPA.DATAFIN
                LEFT JOIN FCT_MOTIVOPARALISACAO MOTIVOPARALISA ON NVL(NEGCONT.NRMOTIVOPARALISACAO, NEGAGRUPA.NRMOTIVOPARALISACAO) = MOTIVOPARALISA.NRMOTIVOPARALISACAO
                LEFT JOIN IDIOMA ON FCT_CONTRATO.CDIDIOM = IDIOMA.CDIDIOM
                LEFT JOIN FCT_MOEDA MOEDA ON FCT_CONTRATO.NRMOEDA = MOEDA.NRMOEDA
                LEFT JOIN FCT_ITEMCONTRATO ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO
                $filtro
                ORDER BY DTINCLUSAO DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPropostaRelatorioContrato($parametros)
    {
        $sql = "SELECT ORC.NRSEQORCAMENTO,
                    ORC.NRORCAMENTO || ' - ' || ORC.DSREFERENCIAORCA AS NMPROPOSTA,
                    ORC.NRORG,
                    ORC.NRORCAMENTO,
                    ORC.NRVERSAOORCAMENTO,
                    ORC.IDSITUACAOORCAMENTO,
                    ORC.DTREFORCAMENTO,
                    ORC.DTACEITEORCA,
                    ORC.NRORCAMENTOMODELO,
                    ORC.CDOPERRESPONSAVEL,
                    OPER.NMOPERADOR AS NMOPERRESPONSAVEL,
                    ORC.NRPARCNEGOCIO,
                    PARC.NMPRINCIPALPARC,
                    MODELO.IDUTILIZACOMP,
                    ORC.DSREFERENCIAORCA,
                    ORC.VRORCAMENTO,
                    ORC.IDATIVO,
                    ORC.DTREFORCAMENTO AS DTINIPROPOSTA,
                    ORC.DTVALIDADE AS DTFINPROPOSTA,
            
            (SELECT LISTAGG(ESCOPO.IDUTILIZAVARPRECO, ',') WITHIN GROUP(
                                                                        ORDER BY ESCOPO.NMTIPOORCAMENTO)
                FROM FCT_TIPOORCAMENTO ESCOPO
                INNER JOIN FCT_RELACESCOPOPROPOSTA REL ON ESCOPO.NRTIPOORCAMENTO = REL.NRTIPOORCAMENTO
                AND ESCOPO.NRORG = REL.NRORG
                WHERE REL.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                AND REL.NRORG = ORC.NRORG ) AS IDUTILIZAVARPRECO,
            
            (SELECT LISTAGG(ESCOPO.NRTIPOORCAMENTO, ',') WITHIN GROUP(
                                                                        ORDER BY ESCOPO.NMTIPOORCAMENTO)
                FROM FCT_TIPOORCAMENTO ESCOPO
                INNER JOIN FCT_RELACESCOPOPROPOSTA REL ON ESCOPO.NRTIPOORCAMENTO = REL.NRTIPOORCAMENTO
                AND ESCOPO.NRORG = REL.NRORG
                WHERE REL.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                AND REL.NRORG = ORC.NRORG ) AS NRTIPOORCAMENTO
            FROM FCT_ORCAMENTO ORC
            LEFT JOIN PARCNEGOCIO PARC ON ORC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
            AND ORC.NRORG = PARC.NRORG
            LEFT JOIN FCT_ORCAMENTOMODELO MODELO ON ORC.NRORCAMENTOMODELO = MODELO.NRORCAMENTOMODELO
            AND ORC.NRORG = MODELO.NRORG
            LEFT JOIN OPERADOR OPER ON ORC.CDOPERRESPONSAVEL = OPER.CDOPERADOR
            AND ORC.NRORG = OPER.NRORG
            LEFT JOIN
            (SELECT NRHIERARQUIAOPER,
                    NRHIERARQUIAPAI,
                    NRORG,
                    CDOPERADOR,
                    IDOPERMASTER,
                    CDFILIAL
                FROM CRM_HIERARQUIAOPER
                WHERE CDOPERADOR =:CDOPERADOR ) HIERARPAI ON HIERARPAI.NRORG = ORC.NRORG
            LEFT JOIN CRM_HIERARQUIAOPER HIERAR ON ORC.CDOPERRESPONSAVEL = HIERAR.CDOPERADOR
            AND ORC.NRORG = HIERAR.NRORG
            LEFT JOIN FCT_PARAMETROGERAL PARAM ON PARAM.NRORG = ORC.NRORG
            WHERE (PARAM.IDUTILIZAHIEROPER = 'N')
            OR (PARAM.IDUTILIZAHIEROPER = 'S'
                AND (ORC.CDOPERRESPONSAVEL IN
                        (SELECT CDOPERADOR
                        FROM CRM_HIERARQUIAOPER
                        WHERE (CRM_HIERARQUIAOPER.CDFILIAL = HIERARPAI.CDFILIAL
                                OR CRM_HIERARQUIAOPER.CDFILIAL IS NULL) CONNECT BY
                            PRIOR CRM_HIERARQUIAOPER.NRHIERARQUIAOPER = CRM_HIERARQUIAOPER.NRHIERARQUIAPAI
                            START WITH CRM_HIERARQUIAOPER.CDOPERADOR = HIERARPAI.CDOPERADOR ))
                OR ORC.CDOPERRESPONSAVEL IS NULL)
            OR (HIERARPAI.IDOPERMASTER = 'S')
            AND EXISTS
                (SELECT 1
                FROM FCT_REFEORCACONT
                WHERE NRSEQORCAMENTO = ORC.NRSEQORCAMENTO)";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getItensRelatorioContrato($filtro)
    {
        $sql = "SELECT FCT_ITEMCONTRATO.NRITEMOCONTRATO, FCT_ITEMCONTRATO.NRSEQCONTRATO, FCT_ITEMCONTRATO.NMITEMCONTRATO,
                FCT_ITEMCONTRATO.NRITEMCONTRATOPAI, FCT_ITEMCONTRATO.QTMEDIDACONTR, FCT_CONTRATO.NRCONTRATOFCT, FCT_TIPOMEDIDASERV.DSTPMEDIDASERV, FCT_ITEMCONTRATO.VRTOTITEMCONT
                    FROM FCT_ITEMCONTRATO
                    LEFT JOIN FCT_CONTRATO
                    ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO
                    LEFT JOIN FCT_TIPOMEDIDASERV
                    ON FCT_TIPOMEDIDASERV.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                    $filtro";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
