/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_EXAME                                   				      */
/* Tabela : EXAME                                                            				      */
/*                                                                      					      */
/* Criao:                                                              				      */
/* 13/12/2004 - Rafael dos Santos Lopes                           				      */
/*                                                                    					      */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_EXAME
BEFORE INSERT OR UPDATE OR DELETE
ON EXAME FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUEXAM := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMEXAME,0) <> NVL(:NEW.NMEXAME,0)) OR
           (NVL(:OLD.CDUNIDEXE,0) <> NVL(:NEW.CDUNIDEXE,0)) OR
           (NVL(:OLD.DSREFFORMULA,0) <> NVL(:NEW.DSREFFORMULA,0)) OR
           (NVL(:OLD.DSFORMEXAM,0) <> NVL(:NEW.DSFORMEXAM,0)) THEN
         :NEW.DTULTATUEXAM := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('EXAME', '', 'CDEXAME='||:OLD.CDEXAME||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE EXAME MODIFY DTULTATUEXAM DEFAULT SYSDATE
/

