/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TRADIDIOMA                                               */
/* Tabela : TRADIDIOMA                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 19/11/2008 - Vanrochris Helbert Vieira                                     */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TRADIDIOMA
BEFORE INSERT OR UPDATE OR DELETE
ON TRADIDIOMA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTRADIDI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.DSIDIOMA, 0) <> NVL(:NEW.DSIDIOMA, 0)) OR
         (NVL(:OLD.DTGERIDITRAD, TO_DATE('31/12/1899', 'DD/MM/YYYY')) <>
          NVL(:NEW.DTGERIDITRAD, TO_DATE('31/12/1899', 'DD/MM/YYYY'))) THEN
         :NEW.DTULTATUTRADIDI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TRADIDIOMA', '', 'IDIDIOMA = '||:OLD.IDIDIOMA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TRADIDIOMA MODIFY DTULTATUTRADIDI DEFAULT SYSDATE
/


-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_OPERPRECOPROP','5.05.018'); END;
/
